#ifndef _attr_h
#define _attr_h

#include "node.h"

struct _list;
struct _node;
typedef struct _attribute {
  char* name;
  char* shortname;
  struct _list* cs;
  struct _attribute *next;	/* list of all attributes */
  struct _attribute *brother;	/* brother is an attr with the same components */
  				/* but with its direction flipped */
  struct _attribute *father;	/* .... but undirected */
  unsigned int mask;		/* key for components */
  void (*TP)(struct _node*, struct _node*, float*, float*);
  int used;
} _attribute, *attribute;

extern attribute newAttr(char*s);
extern attribute brotherAttr(attribute);
extern attribute fatherAttr(attribute);

#define DUMMY_NODE_NAME "@dummy"
#define DRAFT_ATTR_NAME "@draft"

extern attribute standard_attr;
extern attribute default_attr;
extern attribute dummy_attr;

extern attribute attributes;

extern void initAttributes();
extern void disposeAttributes();
extern void printAllAttributes();
extern void reverseAllAttributes();
extern void completeAttrs();

extern void insertComponents(struct _list*,attribute);
extern int isValidAttrComponent(char*);

extern char* shortAttrName(attribute);

extern void printPSCodeOfUsedComps();
extern void printPSAttributeDefs();

extern void useDraftAttr();

#endif
