#include <stdio.h>
#include <stdlib.h>

#include "io.h"

extern FILE* yyin;
extern int yylineno;

int checkOnlyFlag;

void error(char*s)
{
  fprintf(stderr, ERRORSTR "%s\n", s);
  if(io_output) fclose(io_output);
  exit(1);
}

void warning(char*s) { fprintf(stderr, WARNINGSTR "%s\n", s); }

extern char yytext[];
int yyerror(char*s)
{ 
  fprintf(stderr, ERRORSTR "`%s' at line %d in `%s'\n", s, yylineno, yytext);
  if(io_output) fclose(io_output);
  exit(1);
  return 1;
}

void prC(char c) { putc(c,io_output); }
void prS(char *s) { fputs(s,io_output); }
void prI(int i) { fprintf(io_output,"%d",i); }

int verboseFlag = 0;

void verbose(char*s)
{
  if(verboseFlag)
    fprintf(stderr, VERBOSESTR "%s\n", s);
}

FILE *io_input=0, *io_output=0;
char *input_file_name = 0, *output_file_name = 0;


void ensureInputFileIsOpen()
{
  if(!io_input)
    {
      if(input_file_name)
        {
          if(!(io_input=fopen(input_file_name,"r")))
            error("can not open file to read");
	  yyin = io_input;
	}
      else
        io_input = stdin;
    }
}
void ensureOutputFileIsOpen()
{
  if(!io_output)
    {
      if(output_file_name)
	{
          if(!(io_output=fopen(output_file_name,"w")))
            error("can not open file to write");
	}
      else
        io_output = stdout;
    }
}
