#include "queue.h"
#include "mem.h"
#include "node.h"
#include "io.h"

/*---------------------------------------------------------------------------.
 | we have the invariant that all dlist elements are refrenced (in the same  |
 | dlist) exactly twice                                                      |
 `---------------------------------------------------------------------------*/
dlist consAtEnd(void* d, dlist l)
{
  dlist new = (dlist) newCell(sizeof(_dlist));
  new->data = d;
  if(l)
    {
      new->next = l;
      new->prev = l->prev;
      l->prev->next = new;
      l->prev = new;
      return l;
    }
  else
    {
      new->next = new->prev = new;
      return new;
    }
}

/*---------------------------------------------------------------------------.
 | this is destruktive                                                       |
 `---------------------------------------------------------------------------*/
dlist cdrAtFront(dlist l)       
{
  dlist res = 0;
  if(l!=l->next)
    {
      l->next->prev = l->prev;
      res = l->prev->next = l->next;
    }
  freeCell(l,sizeof(_dlist));
  return res;
}

void* carAtFront(dlist l) { return l->data; }

queue insertInSortedQueue(void*d, queue qIn, int(*f)(void*,void*))
{
  queue q, start, new;

  if(qIn)
    {
      start = q = qIn;
      do
        {
	  if( (*f)(d, car(q)) >= 0 )
	    break;
	  q = cdr(q);
	}
      while(q != start);
      new = newCell(sizeof(_dlist));
      new->data = d;
      new->next = q; new->prev = q->prev;
      q->prev = new; new->prev->next = new;
      return qIn;
    }
  else
    {
      new = newCell(sizeof(_dlist));
      new->data = d;
      new->next = new->prev = new;
      return new;
    }
}
