#ifndef _symbols_h
#define _symbols_h

#include "node.h"
#include "attr.h"

#define ATTR 1
#define NODE 2

/* a symbol can be both an attribute and a node */

typedef struct _symbol {
  int type;
  char* name;
  attribute attr;
  node def;
  struct _symbol* next;
} _symbol, *symbol;

symbol findSymbol(char*);
attribute findAttr(char*);
node findNode(char*);

extern attribute makeAttr(symbol);
extern node makeNode(symbol);
extern char* makeStr(symbol);

int isDefined(symbol);

extern list unresolved;
extern void partialInsertList(node,list);

typedef struct _edge_parameters {
  int direction;
  node destination;
  attribute attr;
} _edge_parameters, *edge_parameters;

extern edge_parameters newEdgeParameters(int,node,attribute);

extern void reverseAllLists();
extern void disposeSymbols();

#endif
